%define _lib32	lib
%define _lib64	lib64

%define _libdir32	%{_exec_prefix}/%{_lib32}
%define	_libdir64	%{_exec_prefix}/%{_lib64}

# define 32-bit arch of multiarch platforms
%define arch_32 %{nil}
%ifarch x86_64
%define arch_32 i386
%endif
%ifarch ppc64
%define arch_32 ppc
%endif

# define target architecture of plugins we want to support
%define target_arch i386

# define target operating system of plugins we want to support
%define target_os linux

# define nspluginswrapper libdir (invariant, including libdir)
%define pkglibdir %{_libdir}/%{name}

# define mozilla plugin dir
%define plugindir %{_libdir}/mozilla/plugins
%define plugindir32 %{_libdir32}/mozilla/plugins

# define to build a biarch package
# XXX really build one package and handle upgrades
%if "%{_arch}:%{arch_32}" == "x86_64:i386"
%define build_biarch		1
%endif
%{expand: %{?_with_biarch:	%%global build_biarch 1}}

Summary:	A compatibility layer for Mozilla/Firefox plugins
Name:		nspluginwrapper
Version:	0.9.91.4
Release:	1%{?dist}
Source0:	http://gwenole.beauchesne.info/projects/nspluginwrapper/files/nspluginwrapper-%{version}%{?svndate:-%{svndate}}.tar.bz2
License:	GPL
Group:		Applications/Internet
URL:		http://gwenole.beauchesne.info/projects/nspluginwrapper/
Provides:	%{name}-%{_arch} = %{version}-%{release}
Requires:	%{name}-%{target_arch} = %{version}-%{release}
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
ExclusiveArch:	x86_64 ppc64

BuildRequires:	pkgconfig
# gtk2-devel 32bits
BuildRequires:	%{_libdir32}/gtk-2.0/include/gdkconfig.h %{_includedir}/gnu/stubs-32.h
BuildRequires:	%{_libdir32}/pkgconfig/gobject-2.0.pc
BuildRequires:	%{_libdir32}/libX11.so %{_libdir32}/libXt.so %{_libdir32}/libICE.so %{_libdir32}/libSM.so
# gtk2-devel 64bits
BuildRequires:	%{_libdir64}/gtk-2.0/include/gdkconfig.h %{_includedir}/gnu/stubs-64.h
BuildRequires:	%{_libdir64}/pkgconfig/gobject-2.0.pc
BuildRequires:	%{_libdir64}/libX11.so %{_libdir64}/libXt.so %{_libdir64}/libICE.so %{_libdir64}/libSM.so

%description
nspluginwrapper makes it possible to use Mozilla/Firefox compatible plugins
compiled for %{target_arch} into Mozilla for another architecture,
e.g. x86_64.

This package consists in:
  * npviewer: the plugin viewer
  * npwrapper.so: the browser-side plugin
  * nspluginwrapper: a tool to manage plugins installation and update

%if %{build_biarch}
%package %{target_arch}
Summary:	A viewer for %{target_arch} compiled Netscape 4 plugins
Group:		Applications/Internet

%description %{target_arch}
nspluginwrapper makes it possible to use Mozilla/Firefox compatible plugins
compiled for %{target_arch} into Mozilla for another architecture, 
e.g. x86_64.

This package consists in:
  * npviewer: the plugin viewer
  * npwrapper.so: the browser-side plugin
  * nspluginwrapper: a tool to manage plugins installation and update

This package provides the npviewer program for %{target_arch}.
%endif

%prep
%setup -q

%build
GTK_CFLAGS="$(pkg-config gtk+-2.0 --cflags)" \
GTK_LDFLAGS="$(pkg-config gtk+-2.0 --libs)" \
	./configure --prefix=%{_prefix} \
	--pkglibdir=%{pkglibdir}	\
	--with-lib32=%{_lib32}		\
	--with-lib64=%{_lib64}

make LSB_LIBS=""

%install
rm -rf $RPM_BUILD_ROOT

make install DESTDIR=$RPM_BUILD_ROOT LSB_LIBS=""

mkdir -p $RPM_BUILD_ROOT%{plugindir} $RPM_BUILD_ROOT%{plugindir32}
ln -s %{pkglibdir}/%{_arch}/%{_os}/npwrapper.so $RPM_BUILD_ROOT%{plugindir}/npwrapper.so

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ "$1" = 1 ]; then
  %{_bindir}/%{name} -v -a -i
else
  %{_bindir}/%{name} -v -a -u
fi

%preun
if [ "$1" = 0 ]; then
  %{_bindir}/%{name} -v -a -r
fi

%files
%defattr(-,root,root,-)
%doc ChangeLog COPYING NEWS README
%{_bindir}/%{name}
%{plugindir}
%dir %{pkglibdir}
%{pkglibdir}/noarch
%dir %{pkglibdir}/%{_arch}
%dir %{pkglibdir}/%{_arch}/%{_os}
%{pkglibdir}/%{_arch}/%{_os}/npconfig
%if ! %{build_biarch}
%{pkglibdir}/%{_arch}/%{_os}/npviewer
%{pkglibdir}/%{_arch}/%{_os}/npviewer.bin
%{pkglibdir}/%{_arch}/%{_os}/libxpcom.so
%endif
%{pkglibdir}/%{_arch}/%{_os}/npwrapper.so

%if %{build_biarch}
%files %{target_arch}
%defattr(-,root,root,-)
%dir %{plugindir32}
%dir %{pkglibdir}/%{target_arch}
%dir %{pkglibdir}/%{target_arch}/%{target_os}
%{pkglibdir}/%{target_arch}/%{target_os}/npviewer
%{pkglibdir}/%{target_arch}/%{target_os}/npviewer.bin
%{pkglibdir}/%{target_arch}/%{target_os}/libxpcom.so
%endif

%changelog
* Thu Apr 05 2007 Remi Collet <Fedora@FamilleCollet.com> - 0.9.91.4-1.fc6.remi
- update to 0.9.91.4, fedora build.

* Mon Apr  2 2007 Gwenole Beauchesne <gb.public@free.fr> 0.9.91.4-1
- use anonymous sockets by default
- don't try to wrap native plugins
- require linux32 for nspluginwrapper-i386
- fix build on systems with SSP enabled by default

* Fri Mar  9 2007 Remi Collet <Fedora@FamilleCollet.com> - 0.9.91.3-1.fc6.remi
- add dist tag

* Mon Mar  5 2007 Remi Collet <Fedora@FamilleCollet.com> - 0.9.91.3-1
- update to 0.9.91.3, fedora build.

* Sun Mar  4 2007 Gwenole Beauchesne <gb.public@free.fr> 0.9.91.3-1
- fix printing with EMBED plugins
- fix build on Debian systems (Rob Andrews)
- use sound wrappers whenever possible on Linux (Flash Player 9)
- don't wait for dying processes (i.e. avoid hangs on NP_Shutdown)

* Thu Feb 15 2007 Dams <anvil[AT]livna.org> - 0.9.91.2-2
- Own 32bit mozilla plugin directory to avoid 32bit browser installation
- Hopefully fixed BuildReqs

* Fri Dec 29 2006 Gwenole Beauchesne <gb.public@free.fr> 0.9.91.2-1
- fix some rare RPC synchronisation issues (flashearth.com)
- fix hangs when the plugin exits unexpectedly (e.g. a crash)

* Tue Dec 26 2006 Gwenole Beauchesne <gb.public@free.fr> 0.9.91.1-1
- fix NPRuntime bridge (VLC plugin)
- fix Mozilla plugins dir creation on NetBSD and FreeBSD hosts
- fix potential buffer overflow in RPC marshalers
- handle empty args for plugin creation (flasharcade.com)

* Thu Dec 21 2006 Gwenole Beauchesne <gb.public@free.fr> 0.9.91-1
- add scripting support through npruntime
- add XEMBED support (mplayer plug-in)
- add NPN_RequestRead() support (Acrobat Reader)
- add support for NetBSD, FreeBSD and non-x86 Linux hosts
- fix ppc64 / ppc32 support
- fix focus problems
- fix some rare hangs (add delayed requests)
- fix libstdc++2 compat glue for broken plugins
- create user mozilla plugins dir if it does not exist yet

* Wed Nov 18 2006 Gwenole Beauchesne <gb.public@free.fr> 0.9.90.4-1
- add printing support (NPP_Print)
- add initial support for Konqueror
- fix post data to a URL (NPN_PostURL, NPN_PostURLNotify)
- reduce plugin load times
- robustify error condition (Darryl L. Miles)

* Tue Sep 19 2006 Gwenole Beauchesne <gb.public@free.fr> 0.9.90.3-1
- fix acrobat reader 7 plugin

* Sun Sep 17 2006 Gwenole Beauchesne <gb.public@free.fr> 0.9.90.2-1
- use a bidirectional communication channel

* Sun Jun  4 2006 Gwenole Beauchesne <gb.public@free.fr> 0.9.90.1-1
- relicense under GPL
- don't use QEMU on IA-64
- handle SuSE Linux Mozilla paths
- portability fixes to non-Linux platforms

* Tue Oct 25 2005 Gwenole Beauchesne <gb.public@free.fr> 0.9.90-1
- first public beta version
